{*************
 *
 * Copyright (c) 1996-97 Anton A. Mints
 *
 * Project....: CEO Vusual Library Components
 * File.......: ACtrlGrd.pas
 * Autor......: Anton A. Mints
 * Date.......: 29 August 1996
 * Description: DB control grid with ReadOnly property
 *
 *************}

unit ACtrlGrd;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  DBCGrids;

type
  ADBCtrlGrid = class(TDBCtrlGrid)
  private
    FReadOnly: Boolean;
    procedure SetReadOnly (Value: Boolean);

  public
    constructor Create (AOwner: TComponent); override;
    procedure KeyDown (var Key: Word; Shift: TShiftState); override;

  published
    property ReadOnly: Boolean read FReadOnly write SetReadOnly;
  end;

procedure Register;

implementation

procedure Register;
begin
  RegisterComponents ('CEO', [ADBCtrlGrid]);
end;

{*******************************************************************}
{*                       CLASS ADBCtrlGrid                         *}
{*******************************************************************}

constructor ADBCtrlGrid.Create (AOwner: TComponent);
begin
  inherited Create (AOwner);
  FReadOnly := False;
end;

procedure ADBCtrlGrid.SetReadOnly (Value: Boolean);
begin
  FReadOnly := Value;
end;

procedure ADBCtrlGrid.KeyDown (var Key: Word; Shift: TShiftState);
begin
  if Assigned (DataSource) and  Assigned (DataSource.DataSet) then
  begin
    if (((Key = VK_RETURN) or (Key = VK_F2)) and ReadOnly) or
       (((Key = VK_DOWN) or (Key = VK_RIGHT)) and
          not (ReadOnly or AllowInsert or DataSource.DataSet.EOF)) then
    Key := 0;
  end;
  inherited KeyDown (Key, Shift);
end;

end.
